# Coupons

Commerce Layer provides a promotional engine built on top of two main resources: [promotions](/core-api-reference/promotions.md) and [promotion rules](/core-api-reference/promotion_rules.md).

Coupons must be associated with [coupon code](/core-api-reference/coupon_codes_promotion_rules.md) promotions rules so that a promotion is triggered when customers enter a specific coupon code at checkout. The number of promotions based on coupons is unlimited. The coupon can be used multiple times and it is considered valid until its usage count exceeds the threshold set by its usage limit. About that:

* Set the `usage_limit` attribute to `1` if you want the code to be used just once.
* Set the `customer_single_use` attribute to `true` if you want it to be used just once per customer.
* Specify a value for the `expires_at` attribute if you want to set an expiration date for the coupon (within the time window in which the associated promotion is active).

The coupon code is also exposed at the [line item](/core-api-reference/line_items.md) level, so that you can check which coupon has been used to trigger that promotion line item. The total number of coupons created for a specific promotion can be checked by inspecting the `coupons_count` attribute on the single promotion type.

{% hint style="info" %}
Coupon codes minimum length is **8** characters, maximum length is **40** characters.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.commercelayer.io/core-api-reference/coupons.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
